/* ===================================================
        Serialize a topic map to the javascript
        necessary to construct it.

		For long result strings, building up strings by
		concatenation is slow.  So we append text fragments
		to an array, then join them at the end.
   ===================================================*/
function saveMap(map){
	var win, src,doc
	var genmsg,topics,Topic,id,names,Name,scopes,Scope
	var occurs,Occur,resourceRef,resourceData,Type
	var t,o,s
	var identity,href
	var str
	var result=new Array()

	// Function definitions
	genmsg="// This Topic Map was automatically generated\n\
// using Javascript.\n\
\n\
var top1,oc,sc,a1,mem,subject,ref,uri,locator\n\
tm1=new topicMap('tm-1')\n\n"

	result[result.length]=genmsg

	// Write topics
	result[result.length]="//================= Topics ============\n"
	topics=map.getTopics()
	for (t in topics){
		Topic=topics[t]
		if (!Topic){continue}
		names=Topic.getNamesFiltered()
		Name=''
		if (names&&names.length){Name=names[0].name}
		Name=fixData(Name)// Fix quotes
		id=Topic.id
		if (!(id&&Name)){continue}
		Type=Topic.instanceOf ||''
		result[result.length]='add_topic(tm1,"'+id+'","'+Name+'","'+Type+'")\n'

		// Subject Identity
		identity=Topic.getIdentity()
		if (identity){		
			result.push('subject=new subjectIdentity()\n')
			ref=identity.getResourceRef()
			uri=ref.getUri()||ref.getLocal()
			if (ref){
				result.push('subject.setResourceRefUri("'+uri+'")\n')
				result.push('tm1.getTopicById("'+id+'").setIdentity(subject)\n')
			}

		}

	}
	result[result.length]='\n'

	// Write occurrences
	result[result.length]="//================= Occurrences ============\n"
	for (t in topics){
		Topic=topics[t]
		if (!Topic){continue}
		id=Topic.id
		occurs=Topic.getOccursFiltered()
		if (!(occurs&&occurs.length)){continue}
		for (o in occurs){
			Occur=occurs[o]
			resourceRef=Occur.getResource()
			resourceData=fixData(Occur.getData())

			resourceData='"'+resourceData+'"'
			Type=Occur.instanceOf

			// Get scope if any
			scopes=Occur.getScopes()
			Scope=''
			if (scopes.length){
				Scope=scopes[0]
				Scope=Scope.topic
			}

			result[result.length]="add_occur(tm1,'"+id+"','"+Type+"',"
			result[result.length]="'"+Scope+"','"+resourceRef+"',"+resourceData+")\n"
		}
		
	}

	result[result.length]='\n'

	// Add scopes of topic names
	result[result.length]="//================ Scopes ===================\n"

	for (t in topics){
		Topic=topics[t]
		if (!Topic){continue}
		names=Topic.getNamesFiltered()
		if (!(names&&names.length)){continue}
		Name=names[0]
		scopes=Name.getScopes()
		if (!scopes.length){continue}
		for (s in scopes){
			Scope=scopes[s].topic
			if (Scope=='st-unconstrained'){continue}
			result[result.length]="top1=tm1.getTopicById('"+Topic.id+"')\n"
			result[result.length]='top1.nameList[0].addScope(new scope("'
			result[result.length]=Scope+'"))\n\n'		
		}
	}
	
	result[result.length]='\n'
    result[result.length]="//================ Associations ================\n"
    var a,assoc,associations
    var m,members,member,role
    var p,players,player

    associations=map.getAssociations()
    for (a in associations){
        assoc=associations[a]
		if (!assoc){continue}
		
        result[result.length]="a1=new association('"+assoc.id+"')\n"
        result[result.length]="a1.instanceOf='"+assoc.instanceOf+"'\n"
        
        members=assoc.getMembers()
        for (m in members){
            member=members[m]
            role=member.roleSpec
            result[result.length]="mem=new member('"+role+"')\n"
            players=member.getPlayers()
            for (p in players){
                player=players[p].id
				if (!player){continue}
                result[result.length]="mem.addPlayer("
                result[result.length]="tm1.getTopicById('"+player+"'))\n"
            }
            result[result.length]="a1.addMember(mem)\n\n"
        } 
        
        scopes=assoc.getScopes()
        for (s in scopes){
            Scope=scopes[s]
            result[result.length]="a1.addScope(new scope('"+Scope.topic+"'))\n"
        }
        
        result[result.length]="\ntm1.addAssoc(a1)\n\n"
    }    
	src=result.join('')
    
	// Write the javascript for the topic map to a
	// separate window
    var html='<body>'
    html+='<form><textarea rows="30" cols="60">'

	win=window.open('','_new')
	doc=win.document
	doc.open()
    
    html+=src
	html+='</textarea><form>'
    html+='</body>'
    doc.writeln(html)
	doc.close()
	win.focus()
}



