/* ================================================
    Output an element. "attributes" is an array 
    of values keyed by attribute names.
===================================================*/
function makeElement(element,attributes,content){
    var stag,etag,Element,atts=''
    var content=content||''
    var empty=(!content)
    var a,atts
    
    stag="<"+element
    if (attributes){
        for (a in attributes){
             atts+=" "+ a+'="'+
                attributes[a]+'"'  
        }
        if (atts){stag+=atts}
    }
    if (empty){Element=stag+"/>\n"}
    else {
        stag+=">\n"
        etag="\n</"+element+">\n"
        Element=stag+content+etag
    }
    return Element
}

function escape_quotes(str){
    if (!str){return ''}
    str=str.replace(/"/g,"&quot;")
    str=str.replace(/'/g,"&apos;")
    return str
}

function escape_lt(str){
    if (!str){return ''}
    str=str.replace(/</g,"&lt;")  
    return str
}

function doScopes(scopes){
    var s,scopes,theScope
    var att,scopeStr=''
    for (s in scopes){
        theScope=scopes[s].topic
        att=new Array()
        att['xlink:href']='#'+theScope
        scopeStr+=makeElement("topicRef",att)
    }
    if (scopeStr){
        scopeStr=makeElement("scope","",scopeStr)
    }
    return scopeStr    
}    

function doNames(topic){
    var names,theName='',nameStr='',n
    var att
    var s,scopes,theScope,scopeStr=''
    var results=''
    names=topic.getNamesFiltered()
    if (!names){return ''}
    for (n in names){
        theName=names[n];
        scopes=theName.getScopes()
        if (scopes){
            nameStr+=doScopes(scopes)
        }        
        nameStr+=makeElement("baseNameString","",theName.name)
        nameStr=makeElement("baseName","",nameStr)        
    }
    return nameStr    
}


function doOccur(Occur){
    var temp='',results='',topicref
    var scopes
    var instance, href,resource
    instance="#"+Occur.instanceOf
    if (instance){
        href=new Array()
        href['xlink:href']=instance
        results=makeElement("instanceOf","",
            makeElement('topicRef',href))
    }
    scopes=Occur.getScopes()
    if (scopes){
        results+=doScopes(scopes)   
    }
    resource=Occur.getResource()
    if (resource){
        href=new Array()
        href['xlink:href']=resource
        results+=makeElement("resourceRef",href)
    }
    else {
        resource=Occur.getData()
        resource='<![CDATA['+resource+']]>'
        results+=makeElement("resourceData",'',resource)
    }
    results=makeElement("occurrence",'',results)
    return results   
}    

function doOccurs(occurrences){
    var o,Occur,results=''
    for (o in occurrences){
        Occur=occurrences[o]
        results+=doOccur(Occur)
    }
    return results
}    

function doTopic(Topic){
    var Type,nameStr,id,att,instance
    var topicStr=''
    var occurs,occurStr=''
	if (!(Topic&&Topic.id)){return ''}
    occurs=Topic.getOccursFiltered()
    if (occurs&&occurs.length){occurStr=doOccurs(occurs)}
    instance=Topic.instanceOf
    if (instance){
	    Type=new Array()
		Type['xlink:href']='#'+instance

		topicStr=makeElement('instanceOf','',makeElement('topicRef',Type))
	}
    att=new Array()
    att['id']=Topic.id
    nameStr=doNames(Topic)
    topicStr+=nameStr+occurStr
    return makeElement('topic',att,topicStr)+'\n'
}    

/*function doTopic(Topic){
    var Type,nameStr,id,att,instance
    var topicStr=''
    var occurs,occurStr=''
    occurs=Topic.getOccursFiltered()
    if (occurs.length){occurStr=doOccurs(occurs)}
    Type=new Array()
    instance=Topic.instanceOf
    if (instance){Type['xlink:href']='#'+instance}
    att=new Array()
    att['id']=Topic.id
    nameStr=doNames(Topic)
    topicStr=nameStr+occurStr
    if (instance){topicStr+=makeElement('instanceOf',Type)}
    return makeElement('topic',att,topicStr)+'\n'
}    */

/* ===================================================
	Serialize a topic map to XTM
===================================================*/
function doTopicmap(map){
    var str=''
    var t,topics
	var a,associations,assoc
	var result=new Array()

    result[0]='<?xml version="1.0" encoding="iso-8859-1"?>\n\
<topicMap xmlns="http://www.topicmaps.org/xtm/1.0/"\n\
	xmlns:xlink="http://www.w3.org/1999/xlink">\n'

    topics=tm1.getTopicsFiltered()
    for (t in topics){
        result[result.length]=doTopic(topics[t])   
    }
	associations=tm1.getAssociations()
	for (a in associations){
		assoc=associations[a]
		result[result.length]=doAssoc(assoc)
	}
    result[result.length]='</topicMap>'
    return result.join('')
}
    

function doAssoc(assoc){
	if (!assoc){return ''}
	
    var m,member,members
    var p,players,player,playerid,playertopic
    var scopes
    var href,instance
    var role
    var str='',playerStr='',memberStr='',assocStr=''
	var temp=''
    members=assoc.getMembers()
    for (m in members){
		if (!m){continue}
		
		temp='';playerStr=''
        member=members[m]
        role='#'+member.roleSpec
		href=new Array()
		href['xlink:href']=role
		memberStr=makeElement('roleSpec','',
			makeElement('topicRef',href))
        players=member.getPlayers()
        for (p in players){
            player=players[p]
            playerid="#"+player.id
            href=new Array()
            href['xlink:href']=playerid
            playerStr+=makeElement('topicRef',href)
        }
		temp=memberStr+playerStr
		str+=makeElement('member','',temp)
    }
	href=new Array()
	instance="#"+assoc.instanceOf
    href['xlink:href']=instance
	assocStr=makeElement('instanceOf','',
		makeElement('topicRef',href))
    scopes=assoc.getScopes()
    if (scopes){
        assocStr+=doScopes(scopes)
    }
	href=new Array()
	href['id']=assoc.id
	assocStr=makeElement('association',href,assocStr+str)
	return assocStr
}    
    
function test(){
    return doTopicmap(tm1)
}    




